"""Unicode Properties (autogen)."""
from __future__ import unicode_literals

unicode_alias = {
    "_": {
        "age": "age",
        "bc": "bidiclass",
        "blk": "block",
        "ccc": "canonicalcombiningclass",
        "dt": "decompositiontype",
        "ea": "eastasianwidth",
        "gc": "generalcategory",
        "gcb": "graphemeclusterbreak",
        "hst": "hangulsyllabletype",
        "jg": "joininggroup",
        "jt": "joiningtype",
        "lb": "linebreak",
        "nfcqc": "nfcquickcheck",
        "nfdqc": "nfdquickcheck",
        "nfkcqc": "nfkcquickcheck",
        "nfkdqc": "nfkdquickcheck",
        "nt": "numerictype",
        "nv": "numericvalue",
        "sb": "sentencebreak",
        "sc": "script",
        "wb": "wordbreak"
    },
    "age": {
        "unassigned": "na",
        "v11": "1.1",
        "v20": "2.0",
        "v21": "2.1",
        "v30": "3.0",
        "v31": "3.1",
        "v32": "3.2",
        "v40": "4.0",
        "v41": "4.1",
        "v50": "5.0",
        "v51": "5.1",
        "v52": "5.2",
        "v60": "6.0",
        "v61": "6.1"
    },
    "bidiclass": {
        "arabicletter": "al",
        "arabicnumber": "an",
        "boundaryneutral": "bn",
        "commonseparator": "cs",
        "europeannumber": "en",
        "europeanseparator": "es",
        "europeanterminator": "et",
        "lefttoright": "l",
        "lefttorightembedding": "lre",
        "lefttorightoverride": "lro",
        "nonspacingmark": "nsm",
        "otherneutral": "on",
        "paragraphseparator": "b",
        "popdirectionalformat": "pdf",
        "righttoleft": "r",
        "righttoleftembedding": "rle",
        "righttoleftoverride": "rlo",
        "segmentseparator": "s",
        "whitespace": "ws"
    },
    "binary": {
        "ahex": "asciihexdigit",
        "alnum": "posixalnum",
        "alpha": "alphabetic",
        "bidic": "bidicontrol",
        "bidim": "bidimirrored",
        "blank": "posixblank",
        "cased": "cased",
        "ce": "compositionexclusion",
        "ci": "caseignorable",
        "compex": "fullcompositionexclusion",
        "cwcf": "changeswhencasefolded",
        "cwcm": "changeswhencasemapped",
        "cwkcf": "changeswhennfkccasefolded",
        "cwl": "changeswhenlowercased",
        "cwt": "changeswhentitlecased",
        "cwu": "changeswhenuppercased",
        "dash": "dash",
        "dep": "deprecated",
        "di": "defaultignorablecodepoint",
        "dia": "diacritic",
        "ext": "extender",
        "graph": "posixgraph",
        "grbase": "graphemebase",
        "grext": "graphemeextend",
        "grlink": "graphemelink",
        "hex": "hexdigit",
        "hyphen": "hyphen",
        "idc": "idcontinue",
        "ideo": "ideographic",
        "ids": "idstart",
        "idsb": "idsbinaryoperator",
        "idst": "idstrinaryoperator",
        "joinc": "joincontrol",
        "loe": "logicalorderexception",
        "lower": "lowercase",
        "math": "math",
        "nchar": "noncharactercodepoint",
        "oalpha": "otheralphabetic",
        "odi": "otherdefaultignorablecodepoint",
        "ogrext": "othergraphemeextend",
        "oidc": "otheridcontinue",
        "oids": "otheridstart",
        "olower": "otherlowercase",
        "omath": "othermath",
        "oupper": "otheruppercase",
        "patsyn": "patternsyntax",
        "patws": "patternwhitespace",
        "print": "posixprint",
        "qmark": "quotationmark",
        "radical": "radical",
        "sd": "softdotted",
        "space": "whitespace",
        "sterm": "sterm",
        "term": "terminalpunctuation",
        "uideo": "unifiedideograph",
        "upper": "uppercase",
        "vs": "variationselector",
        "wspace": "whitespace",
        "xdigit": "posixxdigit",
        "xidc": "xidcontinue",
        "xids": "xidstart"
    },
    "block": {
        "alchemical": "alchemicalsymbols",
        "alphabeticpf": "alphabeticpresentationforms",
        "ancientgreekmusic": "ancientgreekmusicalnotation",
        "arabicexta": "arabicextendeda",
        "arabicmath": "arabicmathematicalalphabeticsymbols",
        "arabicpfa": "arabicpresentationformsa",
        "arabicpfb": "arabicpresentationformsb",
        "arabicsup": "arabicsupplement",
        "ascii": "basiclatin",
        "bamumsup": "bamumsupplement",
        "bopomofoext": "bopomofoextended",
        "braille": "braillepatterns",
        "byzantinemusic": "byzantinemusicalsymbols",
        "canadiansyllabics": "unifiedcanadianaboriginalsyllabics",
        "cjk": "cjkunifiedideographs",
        "cjkcompat": "cjkcompatibility",
        "cjkcompatforms": "cjkcompatibilityforms",
        "cjkcompatideographs": "cjkcompatibilityideographs",
        "cjkcompatideographssup": "cjkcompatibilityideographssupplement",
        "cjkexta": "cjkunifiedideographsextensiona",
        "cjkextb": "cjkunifiedideographsextensionb",
        "cjkextc": "cjkunifiedideographsextensionc",
        "cjkextd": "cjkunifiedideographsextensiond",
        "cjkradicalssup": "cjkradicalssupplement",
        "cjksymbols": "cjksymbolsandpunctuation",
        "combiningmarksforsymbols": "combiningdiacriticalmarksforsymbols",
        "compatjamo": "hangulcompatibilityjamo",
        "countingrod": "countingrodnumerals",
        "cuneiformnumbers": "cuneiformnumbersandpunctuation",
        "cyrillicexta": "cyrillicextendeda",
        "cyrillicextb": "cyrillicextendedb",
        "cyrillicsup": "cyrillicsupplement",
        "cyrillicsupplementary": "cyrillicsupplement",
        "devanagariext": "devanagariextended",
        "diacriticals": "combiningdiacriticalmarks",
        "diacriticalsforsymbols": "combiningdiacriticalmarksforsymbols",
        "diacriticalssup": "combiningdiacriticalmarkssupplement",
        "domino": "dominotiles",
        "enclosedalphanum": "enclosedalphanumerics",
        "enclosedalphanumsup": "enclosedalphanumericsupplement",
        "enclosedcjk": "enclosedcjklettersandmonths",
        "enclosedideographicsup": "enclosedideographicsupplement",
        "ethiopicext": "ethiopicextended",
        "ethiopicexta": "ethiopicextendeda",
        "ethiopicsup": "ethiopicsupplement",
        "georgiansup": "georgiansupplement",
        "greek": "greekandcoptic",
        "greekext": "greekextended",
        "halfandfullforms": "halfwidthandfullwidthforms",
        "halfmarks": "combininghalfmarks",
        "hangul": "hangulsyllables",
        "highpusurrogates": "highprivateusesurrogates",
        "idc": "ideographicdescriptioncharacters",
        "indicnumberforms": "commonindicnumberforms",
        "ipaext": "ipaextensions",
        "jamo": "hanguljamo",
        "jamoexta": "hanguljamoextendeda",
        "jamoextb": "hanguljamoextendedb",
        "kanasup": "kanasupplement",
        "kangxi": "kangxiradicals",
        "katakanaext": "katakanaphoneticextensions",
        "latin1": "latin1supplement",
        "latin1sup": "latin1supplement",
        "latinexta": "latinextendeda",
        "latinextadditional": "latinextendedadditional",
        "latinextb": "latinextendedb",
        "latinextc": "latinextendedc",
        "latinextd": "latinextendedd",
        "mahjong": "mahjongtiles",
        "mathalphanum": "mathematicalalphanumericsymbols",
        "mathoperators": "mathematicaloperators",
        "meeteimayekext": "meeteimayekextensions",
        "miscarrows": "miscellaneoussymbolsandarrows",
        "miscmathsymbolsa": "miscellaneousmathematicalsymbolsa",
        "miscmathsymbolsb": "miscellaneousmathematicalsymbolsb",
        "miscpictographs": "miscellaneoussymbolsandpictographs",
        "miscsymbols": "miscellaneoussymbols",
        "misctechnical": "miscellaneoustechnical",
        "modifierletters": "spacingmodifierletters",
        "music": "musicalsymbols",
        "myanmarexta": "myanmarextendeda",
        "nb": "noblock",
        "ocr": "opticalcharacterrecognition",
        "phaistos": "phaistosdisc",
        "phoneticext": "phoneticextensions",
        "phoneticextsup": "phoneticextensionssupplement",
        "privateuse": "privateusearea",
        "pua": "privateusearea",
        "punctuation": "generalpunctuation",
        "rumi": "ruminumeralsymbols",
        "smallforms": "smallformvariants",
        "sundanesesup": "sundanesesupplement",
        "suparrowsa": "supplementalarrowsa",
        "suparrowsb": "supplementalarrowsb",
        "superandsub": "superscriptsandsubscripts",
        "supmathoperators": "supplementalmathematicaloperators",
        "suppuaa": "supplementaryprivateuseareaa",
        "suppuab": "supplementaryprivateuseareab",
        "suppunctuation": "supplementalpunctuation",
        "taixuanjing": "taixuanjingsymbols",
        "transportandmap": "transportandmapsymbols",
        "ucas": "unifiedcanadianaboriginalsyllabics",
        "ucasext": "unifiedcanadianaboriginalsyllabicsextended",
        "vedicext": "vedicextensions",
        "vs": "variationselectors",
        "vssup": "variationselectorssupplement",
        "yijing": "yijinghexagramsymbols"
    },
    "canonicalcombiningclass": {
        "a": "230",
        "above": "230",
        "aboveleft": "228",
        "aboveright": "232",
        "al": "228",
        "ar": "232",
        "ata": "214",
        "atar": "216",
        "atb": "202",
        "atbl": "200",
        "attachedabove": "214",
        "attachedaboveright": "216",
        "attachedbelow": "202",
        "attachedbelowleft": "200",
        "b": "220",
        "below": "220",
        "belowleft": "218",
        "belowright": "222",
        "bl": "218",
        "br": "222",
        "ccc10": "10",
        "ccc103": "103",
        "ccc107": "107",
        "ccc11": "11",
        "ccc118": "118",
        "ccc12": "12",
        "ccc122": "122",
        "ccc129": "129",
        "ccc13": "13",
        "ccc130": "130",
        "ccc133": "132",
        "ccc14": "14",
        "ccc15": "15",
        "ccc16": "16",
        "ccc17": "17",
        "ccc18": "18",
        "ccc19": "19",
        "ccc20": "20",
        "ccc21": "21",
        "ccc22": "22",
        "ccc23": "23",
        "ccc24": "24",
        "ccc25": "25",
        "ccc26": "26",
        "ccc27": "27",
        "ccc28": "28",
        "ccc29": "29",
        "ccc30": "30",
        "ccc31": "31",
        "ccc32": "32",
        "ccc33": "33",
        "ccc34": "34",
        "ccc35": "35",
        "ccc36": "36",
        "ccc84": "84",
        "ccc91": "91",
        "da": "234",
        "db": "233",
        "doubleabove": "234",
        "doublebelow": "233",
        "iotasubscript": "240",
        "is": "240",
        "kanavoicing": "8",
        "kv": "8",
        "l": "224",
        "left": "224",
        "nk": "7",
        "notreordered": "0",
        "nr": "0",
        "nukta": "7",
        "ov": "1",
        "overlay": "1",
        "r": "226",
        "right": "226",
        "virama": "9",
        "vr": "9"
    },
    "decompositiontype": {
        "can": "canonical",
        "com": "compat",
        "enc": "circle",
        "fin": "final",
        "fra": "fraction",
        "init": "initial",
        "iso": "isolated",
        "med": "medial",
        "nar": "narrow",
        "nb": "nobreak",
        "sml": "small",
        "sqr": "square",
        "sup": "super",
        "vert": "vertical"
    },
    "eastasianwidth": {
        "ambiguous": "a",
        "fullwidth": "f",
        "halfwidth": "h",
        "narrow": "na",
        "neutral": "n",
        "wide": "w"
    },
    "generalcategory": {
        "casedletter": "lc",
        "closepunctuation": "pe",
        "cntrl": "cc",
        "combiningmark": "m",
        "connectorpunctuation": "pc",
        "control": "cc",
        "currencysymbol": "sc",
        "dashpunctuation": "pd",
        "decimalnumber": "nd",
        "digit": "nd",
        "enclosingmark": "me",
        "finalpunctuation": "pf",
        "format": "cf",
        "initialpunctuation": "pi",
        "letter": "l",
        "letternumber": "nl",
        "lineseparator": "zl",
        "lowercaseletter": "ll",
        "mark": "m",
        "mathsymbol": "sm",
        "modifierletter": "lm",
        "modifiersymbol": "sk",
        "nonspacingmark": "mn",
        "number": "n",
        "openpunctuation": "ps",
        "other": "c",
        "otherletter": "lo",
        "othernumber": "no",
        "otherpunctuation": "po",
        "othersymbol": "so",
        "paragraphseparator": "zp",
        "privateuse": "co",
        "punct": "p",
        "punctuation": "p",
        "separator": "z",
        "spaceseparator": "zs",
        "spacingmark": "mc",
        "surrogate": "cs",
        "symbol": "s",
        "titlecaseletter": "lt",
        "unassigned": "cn",
        "uppercaseletter": "lu"
    },
    "graphemeclusterbreak": {
        "cn": "control",
        "ex": "extend",
        "pp": "prepend",
        "sm": "spacingmark",
        "xx": "other"
    },
    "hangulsyllabletype": {
        "leadingjamo": "l",
        "lvsyllable": "lv",
        "lvtsyllable": "lvt",
        "notapplicable": "na",
        "trailingjamo": "t",
        "voweljamo": "v"
    },
    "joininggroup": {
        "tehmarbutagoal": "hamzaonhehgoal"
    },
    "joiningtype": {
        "dualjoining": "d",
        "joincausing": "c",
        "leftjoining": "l",
        "nonjoining": "u",
        "rightjoining": "r",
        "transparent": "t"
    },
    "linebreak": {
        "ai": "ambiguous",
        "al": "alphabetic",
        "b2": "breakboth",
        "ba": "breakafter",
        "bb": "breakbefore",
        "bk": "mandatorybreak",
        "cb": "contingentbreak",
        "cj": "conditionaljapanesestarter",
        "cl": "closepunctuation",
        "cm": "combiningmark",
        "cp": "closeparenthesis",
        "cr": "carriagereturn",
        "ex": "exclamation",
        "gl": "glue",
        "hl": "hebrewletter",
        "hy": "hyphen",
        "id": "ideographic",
        "in": "inseparable",
        "inseperable": "inseparable",
        "is": "infixnumeric",
        "lf": "linefeed",
        "nl": "nextline",
        "ns": "nonstarter",
        "nu": "numeric",
        "op": "openpunctuation",
        "po": "postfixnumeric",
        "pr": "prefixnumeric",
        "qu": "quotation",
        "sa": "complexcontext",
        "sg": "surrogate",
        "sp": "space",
        "sy": "breaksymbols",
        "wj": "wordjoiner",
        "xx": "unknown",
        "zw": "zwspace"
    },
    "nfcquickcheck": {
        "maybe": "m",
        "no": "n",
        "yes": "y"
    },
    "nfdquickcheck": {
        "no": "n",
        "yes": "y"
    },
    "nfkcquickcheck": {
        "maybe": "m",
        "no": "n",
        "yes": "y"
    },
    "nfkdquickcheck": {
        "no": "n",
        "yes": "y"
    },
    "numerictype": {
        "de": "decimal",
        "di": "digit",
        "nu": "numeric"
    },
    "numericvalue": {
    },
    "script": {
        "arab": "arabic",
        "armi": "imperialaramaic",
        "armn": "armenian",
        "avst": "avestan",
        "bali": "balinese",
        "bamu": "bamum",
        "batk": "batak",
        "beng": "bengali",
        "bopo": "bopomofo",
        "brah": "brahmi",
        "brai": "braille",
        "bugi": "buginese",
        "buhd": "buhid",
        "cakm": "chakma",
        "cans": "canadianaboriginal",
        "cari": "carian",
        "cher": "cherokee",
        "copt": "coptic",
        "cprt": "cypriot",
        "cyrl": "cyrillic",
        "deva": "devanagari",
        "dsrt": "deseret",
        "egyp": "egyptianhieroglyphs",
        "ethi": "ethiopic",
        "geor": "georgian",
        "glag": "glagolitic",
        "goth": "gothic",
        "grek": "greek",
        "gujr": "gujarati",
        "guru": "gurmukhi",
        "hang": "hangul",
        "hani": "han",
        "hano": "hanunoo",
        "hebr": "hebrew",
        "hira": "hiragana",
        "hrkt": "katakanaorhiragana",
        "ital": "olditalic",
        "java": "javanese",
        "kali": "kayahli",
        "kana": "katakana",
        "khar": "kharoshthi",
        "khmr": "khmer",
        "knda": "kannada",
        "kthi": "kaithi",
        "lana": "taitham",
        "laoo": "lao",
        "latn": "latin",
        "lepc": "lepcha",
        "limb": "limbu",
        "linb": "linearb",
        "lyci": "lycian",
        "lydi": "lydian",
        "mand": "mandaic",
        "merc": "meroiticcursive",
        "mero": "meroitichieroglyphs",
        "mlym": "malayalam",
        "mong": "mongolian",
        "mtei": "meeteimayek",
        "mymr": "myanmar",
        "nkoo": "nko",
        "ogam": "ogham",
        "olck": "olchiki",
        "orkh": "oldturkic",
        "orya": "oriya",
        "osma": "osmanya",
        "phag": "phagspa",
        "phli": "inscriptionalpahlavi",
        "phnx": "phoenician",
        "plrd": "miao",
        "prti": "inscriptionalparthian",
        "qaac": "coptic",
        "qaai": "inherited",
        "rjng": "rejang",
        "runr": "runic",
        "samr": "samaritan",
        "sarb": "oldsoutharabian",
        "saur": "saurashtra",
        "shaw": "shavian",
        "shrd": "sharada",
        "sinh": "sinhala",
        "sora": "sorasompeng",
        "sund": "sundanese",
        "sylo": "sylotinagri",
        "syrc": "syriac",
        "tagb": "tagbanwa",
        "takr": "takri",
        "tale": "taile",
        "talu": "newtailue",
        "taml": "tamil",
        "tavt": "taiviet",
        "telu": "telugu",
        "tfng": "tifinagh",
        "tglg": "tagalog",
        "thaa": "thaana",
        "tibt": "tibetan",
        "ugar": "ugaritic",
        "vaii": "vai",
        "xpeo": "oldpersian",
        "xsux": "cuneiform",
        "yiii": "yi",
        "zinh": "inherited",
        "zyyy": "common",
        "zzzz": "unknown"
    },
    "sentencebreak": {
        "at": "aterm",
        "cl": "close",
        "ex": "extend",
        "fo": "format",
        "le": "oletter",
        "lo": "lower",
        "nu": "numeric",
        "sc": "scontinue",
        "se": "sep",
        "st": "sterm",
        "up": "upper",
        "xx": "other"
    },
    "wordbreak": {
        "ex": "extendnumlet",
        "fo": "format",
        "ka": "katakana",
        "le": "aletter",
        "mb": "midnumlet",
        "ml": "midletter",
        "mn": "midnum",
        "nl": "newline",
        "nu": "numeric",
        "xx": "other"
    }
}
enum_names = {
    "age",
    "bc",
    "bidiclass",
    "blk",
    "block",
    "canonicalcombiningclass",
    "ccc",
    "decompositiontype",
    "dt",
    "ea",
    "eastasianwidth",
    "gc",
    "gcb",
    "generalcategory",
    "graphemeclusterbreak",
    "hangulsyllabletype",
    "hst",
    "jg",
    "joininggroup",
    "joiningtype",
    "jt",
    "lb",
    "linebreak",
    "nfcqc",
    "nfcquickcheck",
    "nfdqc",
    "nfdquickcheck",
    "nfkcqc",
    "nfkcquickcheck",
    "nfkdqc",
    "nfkdquickcheck",
    "nt",
    "numerictype",
    "numericvalue",
    "nv",
    "sb",
    "sc",
    "script",
    "sentencebreak",
    "wb",
    "wordbreak"
}
