"""Unicode Properties (autogen)."""
from __future__ import unicode_literals

unicode_blocks = {
    "basiclatin": "\u0000-\u007f",
    "^basiclatin": "\u0080-\U0010ffff",
    "latin1supplement": "\u0080-\u00ff",
    "^latin1supplement": "\u0000-\u007f\u0100-\U0010ffff",
    "latinextendeda": "\u0100-\u017f",
    "^latinextendeda": "\u0000-\u00ff\u0180-\U0010ffff",
    "latinextendedb": "\u0180-\u024f",
    "^latinextendedb": "\u0000-\u017f\u0250-\U0010ffff",
    "ipaextensions": "\u0250-\u02af",
    "^ipaextensions": "\u0000-\u024f\u02b0-\U0010ffff",
    "spacingmodifierletters": "\u02b0-\u02ff",
    "^spacingmodifierletters": "\u0000-\u02af\u0300-\U0010ffff",
    "combiningdiacriticalmarks": "\u0300-\u036f",
    "^combiningdiacriticalmarks": "\u0000-\u02ff\u0370-\U0010ffff",
    "greekandcoptic": "\u0370-\u03ff",
    "^greekandcoptic": "\u0000-\u036f\u0400-\U0010ffff",
    "cyrillic": "\u0400-\u04ff",
    "^cyrillic": "\u0000-\u03ff\u0500-\U0010ffff",
    "cyrillicsupplement": "\u0500-\u052f",
    "^cyrillicsupplement": "\u0000-\u04ff\u0530-\U0010ffff",
    "armenian": "\u0530-\u058f",
    "^armenian": "\u0000-\u052f\u0590-\U0010ffff",
    "hebrew": "\u0590-\u05ff",
    "^hebrew": "\u0000-\u058f\u0600-\U0010ffff",
    "arabic": "\u0600-\u06ff",
    "^arabic": "\u0000-\u05ff\u0700-\U0010ffff",
    "syriac": "\u0700-\u074f",
    "^syriac": "\u0000-\u06ff\u0750-\U0010ffff",
    "arabicsupplement": "\u0750-\u077f",
    "^arabicsupplement": "\u0000-\u074f\u0780-\U0010ffff",
    "thaana": "\u0780-\u07bf",
    "^thaana": "\u0000-\u077f\u07c0-\U0010ffff",
    "nko": "\u07c0-\u07ff",
    "^nko": "\u0000-\u07bf\u0800-\U0010ffff",
    "samaritan": "\u0800-\u083f",
    "^samaritan": "\u0000-\u07ff\u0840-\U0010ffff",
    "mandaic": "\u0840-\u085f",
    "^mandaic": "\u0000-\u083f\u0860-\U0010ffff",
    "arabicextendeda": "\u08a0-\u08ff",
    "^arabicextendeda": "\u0000-\u089f\u0900-\U0010ffff",
    "devanagari": "\u0900-\u097f",
    "^devanagari": "\u0000-\u08ff\u0980-\U0010ffff",
    "bengali": "\u0980-\u09ff",
    "^bengali": "\u0000-\u097f\u0a00-\U0010ffff",
    "gurmukhi": "\u0a00-\u0a7f",
    "^gurmukhi": "\u0000-\u09ff\u0a80-\U0010ffff",
    "gujarati": "\u0a80-\u0aff",
    "^gujarati": "\u0000-\u0a7f\u0b00-\U0010ffff",
    "oriya": "\u0b00-\u0b7f",
    "^oriya": "\u0000-\u0aff\u0b80-\U0010ffff",
    "tamil": "\u0b80-\u0bff",
    "^tamil": "\u0000-\u0b7f\u0c00-\U0010ffff",
    "telugu": "\u0c00-\u0c7f",
    "^telugu": "\u0000-\u0bff\u0c80-\U0010ffff",
    "kannada": "\u0c80-\u0cff",
    "^kannada": "\u0000-\u0c7f\u0d00-\U0010ffff",
    "malayalam": "\u0d00-\u0d7f",
    "^malayalam": "\u0000-\u0cff\u0d80-\U0010ffff",
    "sinhala": "\u0d80-\u0dff",
    "^sinhala": "\u0000-\u0d7f\u0e00-\U0010ffff",
    "thai": "\u0e00-\u0e7f",
    "^thai": "\u0000-\u0dff\u0e80-\U0010ffff",
    "lao": "\u0e80-\u0eff",
    "^lao": "\u0000-\u0e7f\u0f00-\U0010ffff",
    "tibetan": "\u0f00-\u0fff",
    "^tibetan": "\u0000-\u0eff\u1000-\U0010ffff",
    "myanmar": "\u1000-\u109f",
    "^myanmar": "\u0000-\u0fff\u10a0-\U0010ffff",
    "georgian": "\u10a0-\u10ff",
    "^georgian": "\u0000-\u109f\u1100-\U0010ffff",
    "hanguljamo": "\u1100-\u11ff",
    "^hanguljamo": "\u0000-\u10ff\u1200-\U0010ffff",
    "ethiopic": "\u1200-\u137f",
    "^ethiopic": "\u0000-\u11ff\u1380-\U0010ffff",
    "ethiopicsupplement": "\u1380-\u139f",
    "^ethiopicsupplement": "\u0000-\u137f\u13a0-\U0010ffff",
    "cherokee": "\u13a0-\u13ff",
    "^cherokee": "\u0000-\u139f\u1400-\U0010ffff",
    "unifiedcanadianaboriginalsyllabics": "\u1400-\u167f",
    "^unifiedcanadianaboriginalsyllabics": "\u0000-\u13ff\u1680-\U0010ffff",
    "ogham": "\u1680-\u169f",
    "^ogham": "\u0000-\u167f\u16a0-\U0010ffff",
    "runic": "\u16a0-\u16ff",
    "^runic": "\u0000-\u169f\u1700-\U0010ffff",
    "tagalog": "\u1700-\u171f",
    "^tagalog": "\u0000-\u16ff\u1720-\U0010ffff",
    "hanunoo": "\u1720-\u173f",
    "^hanunoo": "\u0000-\u171f\u1740-\U0010ffff",
    "buhid": "\u1740-\u175f",
    "^buhid": "\u0000-\u173f\u1760-\U0010ffff",
    "tagbanwa": "\u1760-\u177f",
    "^tagbanwa": "\u0000-\u175f\u1780-\U0010ffff",
    "khmer": "\u1780-\u17ff",
    "^khmer": "\u0000-\u177f\u1800-\U0010ffff",
    "mongolian": "\u1800-\u18af",
    "^mongolian": "\u0000-\u17ff\u18b0-\U0010ffff",
    "unifiedcanadianaboriginalsyllabicsextended": "\u18b0-\u18ff",
    "^unifiedcanadianaboriginalsyllabicsextended": "\u0000-\u18af\u1900-\U0010ffff",
    "limbu": "\u1900-\u194f",
    "^limbu": "\u0000-\u18ff\u1950-\U0010ffff",
    "taile": "\u1950-\u197f",
    "^taile": "\u0000-\u194f\u1980-\U0010ffff",
    "newtailue": "\u1980-\u19df",
    "^newtailue": "\u0000-\u197f\u19e0-\U0010ffff",
    "khmersymbols": "\u19e0-\u19ff",
    "^khmersymbols": "\u0000-\u19df\u1a00-\U0010ffff",
    "buginese": "\u1a00-\u1a1f",
    "^buginese": "\u0000-\u19ff\u1a20-\U0010ffff",
    "taitham": "\u1a20-\u1aaf",
    "^taitham": "\u0000-\u1a1f\u1ab0-\U0010ffff",
    "balinese": "\u1b00-\u1b7f",
    "^balinese": "\u0000-\u1aff\u1b80-\U0010ffff",
    "sundanese": "\u1b80-\u1bbf",
    "^sundanese": "\u0000-\u1b7f\u1bc0-\U0010ffff",
    "batak": "\u1bc0-\u1bff",
    "^batak": "\u0000-\u1bbf\u1c00-\U0010ffff",
    "lepcha": "\u1c00-\u1c4f",
    "^lepcha": "\u0000-\u1bff\u1c50-\U0010ffff",
    "olchiki": "\u1c50-\u1c7f",
    "^olchiki": "\u0000-\u1c4f\u1c80-\U0010ffff",
    "sundanesesupplement": "\u1cc0-\u1ccf",
    "^sundanesesupplement": "\u0000-\u1cbf\u1cd0-\U0010ffff",
    "vedicextensions": "\u1cd0-\u1cff",
    "^vedicextensions": "\u0000-\u1ccf\u1d00-\U0010ffff",
    "phoneticextensions": "\u1d00-\u1d7f",
    "^phoneticextensions": "\u0000-\u1cff\u1d80-\U0010ffff",
    "phoneticextensionssupplement": "\u1d80-\u1dbf",
    "^phoneticextensionssupplement": "\u0000-\u1d7f\u1dc0-\U0010ffff",
    "combiningdiacriticalmarkssupplement": "\u1dc0-\u1dff",
    "^combiningdiacriticalmarkssupplement": "\u0000-\u1dbf\u1e00-\U0010ffff",
    "latinextendedadditional": "\u1e00-\u1eff",
    "^latinextendedadditional": "\u0000-\u1dff\u1f00-\U0010ffff",
    "greekextended": "\u1f00-\u1fff",
    "^greekextended": "\u0000-\u1eff\u2000-\U0010ffff",
    "generalpunctuation": "\u2000-\u206f",
    "^generalpunctuation": "\u0000-\u1fff\u2070-\U0010ffff",
    "superscriptsandsubscripts": "\u2070-\u209f",
    "^superscriptsandsubscripts": "\u0000-\u206f\u20a0-\U0010ffff",
    "currencysymbols": "\u20a0-\u20cf",
    "^currencysymbols": "\u0000-\u209f\u20d0-\U0010ffff",
    "combiningdiacriticalmarksforsymbols": "\u20d0-\u20ff",
    "^combiningdiacriticalmarksforsymbols": "\u0000-\u20cf\u2100-\U0010ffff",
    "letterlikesymbols": "\u2100-\u214f",
    "^letterlikesymbols": "\u0000-\u20ff\u2150-\U0010ffff",
    "numberforms": "\u2150-\u218f",
    "^numberforms": "\u0000-\u214f\u2190-\U0010ffff",
    "arrows": "\u2190-\u21ff",
    "^arrows": "\u0000-\u218f\u2200-\U0010ffff",
    "mathematicaloperators": "\u2200-\u22ff",
    "^mathematicaloperators": "\u0000-\u21ff\u2300-\U0010ffff",
    "miscellaneoustechnical": "\u2300-\u23ff",
    "^miscellaneoustechnical": "\u0000-\u22ff\u2400-\U0010ffff",
    "controlpictures": "\u2400-\u243f",
    "^controlpictures": "\u0000-\u23ff\u2440-\U0010ffff",
    "opticalcharacterrecognition": "\u2440-\u245f",
    "^opticalcharacterrecognition": "\u0000-\u243f\u2460-\U0010ffff",
    "enclosedalphanumerics": "\u2460-\u24ff",
    "^enclosedalphanumerics": "\u0000-\u245f\u2500-\U0010ffff",
    "boxdrawing": "\u2500-\u257f",
    "^boxdrawing": "\u0000-\u24ff\u2580-\U0010ffff",
    "blockelements": "\u2580-\u259f",
    "^blockelements": "\u0000-\u257f\u25a0-\U0010ffff",
    "geometricshapes": "\u25a0-\u25ff",
    "^geometricshapes": "\u0000-\u259f\u2600-\U0010ffff",
    "miscellaneoussymbols": "\u2600-\u26ff",
    "^miscellaneoussymbols": "\u0000-\u25ff\u2700-\U0010ffff",
    "dingbats": "\u2700-\u27bf",
    "^dingbats": "\u0000-\u26ff\u27c0-\U0010ffff",
    "miscellaneousmathematicalsymbolsa": "\u27c0-\u27ef",
    "^miscellaneousmathematicalsymbolsa": "\u0000-\u27bf\u27f0-\U0010ffff",
    "supplementalarrowsa": "\u27f0-\u27ff",
    "^supplementalarrowsa": "\u0000-\u27ef\u2800-\U0010ffff",
    "braillepatterns": "\u2800-\u28ff",
    "^braillepatterns": "\u0000-\u27ff\u2900-\U0010ffff",
    "supplementalarrowsb": "\u2900-\u297f",
    "^supplementalarrowsb": "\u0000-\u28ff\u2980-\U0010ffff",
    "miscellaneousmathematicalsymbolsb": "\u2980-\u29ff",
    "^miscellaneousmathematicalsymbolsb": "\u0000-\u297f\u2a00-\U0010ffff",
    "supplementalmathematicaloperators": "\u2a00-\u2aff",
    "^supplementalmathematicaloperators": "\u0000-\u29ff\u2b00-\U0010ffff",
    "miscellaneoussymbolsandarrows": "\u2b00-\u2bff",
    "^miscellaneoussymbolsandarrows": "\u0000-\u2aff\u2c00-\U0010ffff",
    "glagolitic": "\u2c00-\u2c5f",
    "^glagolitic": "\u0000-\u2bff\u2c60-\U0010ffff",
    "latinextendedc": "\u2c60-\u2c7f",
    "^latinextendedc": "\u0000-\u2c5f\u2c80-\U0010ffff",
    "coptic": "\u2c80-\u2cff",
    "^coptic": "\u0000-\u2c7f\u2d00-\U0010ffff",
    "georgiansupplement": "\u2d00-\u2d2f",
    "^georgiansupplement": "\u0000-\u2cff\u2d30-\U0010ffff",
    "tifinagh": "\u2d30-\u2d7f",
    "^tifinagh": "\u0000-\u2d2f\u2d80-\U0010ffff",
    "ethiopicextended": "\u2d80-\u2ddf",
    "^ethiopicextended": "\u0000-\u2d7f\u2de0-\U0010ffff",
    "cyrillicextendeda": "\u2de0-\u2dff",
    "^cyrillicextendeda": "\u0000-\u2ddf\u2e00-\U0010ffff",
    "supplementalpunctuation": "\u2e00-\u2e7f",
    "^supplementalpunctuation": "\u0000-\u2dff\u2e80-\U0010ffff",
    "cjkradicalssupplement": "\u2e80-\u2eff",
    "^cjkradicalssupplement": "\u0000-\u2e7f\u2f00-\U0010ffff",
    "kangxiradicals": "\u2f00-\u2fdf",
    "^kangxiradicals": "\u0000-\u2eff\u2fe0-\U0010ffff",
    "ideographicdescriptioncharacters": "\u2ff0-\u2fff",
    "^ideographicdescriptioncharacters": "\u0000-\u2fef\u3000-\U0010ffff",
    "cjksymbolsandpunctuation": "\u3000-\u303f",
    "^cjksymbolsandpunctuation": "\u0000-\u2fff\u3040-\U0010ffff",
    "hiragana": "\u3040-\u309f",
    "^hiragana": "\u0000-\u303f\u30a0-\U0010ffff",
    "katakana": "\u30a0-\u30ff",
    "^katakana": "\u0000-\u309f\u3100-\U0010ffff",
    "bopomofo": "\u3100-\u312f",
    "^bopomofo": "\u0000-\u30ff\u3130-\U0010ffff",
    "hangulcompatibilityjamo": "\u3130-\u318f",
    "^hangulcompatibilityjamo": "\u0000-\u312f\u3190-\U0010ffff",
    "kanbun": "\u3190-\u319f",
    "^kanbun": "\u0000-\u318f\u31a0-\U0010ffff",
    "bopomofoextended": "\u31a0-\u31bf",
    "^bopomofoextended": "\u0000-\u319f\u31c0-\U0010ffff",
    "cjkstrokes": "\u31c0-\u31ef",
    "^cjkstrokes": "\u0000-\u31bf\u31f0-\U0010ffff",
    "katakanaphoneticextensions": "\u31f0-\u31ff",
    "^katakanaphoneticextensions": "\u0000-\u31ef\u3200-\U0010ffff",
    "enclosedcjklettersandmonths": "\u3200-\u32ff",
    "^enclosedcjklettersandmonths": "\u0000-\u31ff\u3300-\U0010ffff",
    "cjkcompatibility": "\u3300-\u33ff",
    "^cjkcompatibility": "\u0000-\u32ff\u3400-\U0010ffff",
    "cjkunifiedideographsextensiona": "\u3400-\u4dbf",
    "^cjkunifiedideographsextensiona": "\u0000-\u33ff\u4dc0-\U0010ffff",
    "yijinghexagramsymbols": "\u4dc0-\u4dff",
    "^yijinghexagramsymbols": "\u0000-\u4dbf\u4e00-\U0010ffff",
    "cjkunifiedideographs": "\u4e00-\u9fff",
    "^cjkunifiedideographs": "\u0000-\u4dff\ua000-\U0010ffff",
    "yisyllables": "\ua000-\ua48f",
    "^yisyllables": "\u0000-\u9fff\ua490-\U0010ffff",
    "yiradicals": "\ua490-\ua4cf",
    "^yiradicals": "\u0000-\ua48f\ua4d0-\U0010ffff",
    "lisu": "\ua4d0-\ua4ff",
    "^lisu": "\u0000-\ua4cf\ua500-\U0010ffff",
    "vai": "\ua500-\ua63f",
    "^vai": "\u0000-\ua4ff\ua640-\U0010ffff",
    "cyrillicextendedb": "\ua640-\ua69f",
    "^cyrillicextendedb": "\u0000-\ua63f\ua6a0-\U0010ffff",
    "bamum": "\ua6a0-\ua6ff",
    "^bamum": "\u0000-\ua69f\ua700-\U0010ffff",
    "modifiertoneletters": "\ua700-\ua71f",
    "^modifiertoneletters": "\u0000-\ua6ff\ua720-\U0010ffff",
    "latinextendedd": "\ua720-\ua7ff",
    "^latinextendedd": "\u0000-\ua71f\ua800-\U0010ffff",
    "sylotinagri": "\ua800-\ua82f",
    "^sylotinagri": "\u0000-\ua7ff\ua830-\U0010ffff",
    "commonindicnumberforms": "\ua830-\ua83f",
    "^commonindicnumberforms": "\u0000-\ua82f\ua840-\U0010ffff",
    "phagspa": "\ua840-\ua87f",
    "^phagspa": "\u0000-\ua83f\ua880-\U0010ffff",
    "saurashtra": "\ua880-\ua8df",
    "^saurashtra": "\u0000-\ua87f\ua8e0-\U0010ffff",
    "devanagariextended": "\ua8e0-\ua8ff",
    "^devanagariextended": "\u0000-\ua8df\ua900-\U0010ffff",
    "kayahli": "\ua900-\ua92f",
    "^kayahli": "\u0000-\ua8ff\ua930-\U0010ffff",
    "rejang": "\ua930-\ua95f",
    "^rejang": "\u0000-\ua92f\ua960-\U0010ffff",
    "hanguljamoextendeda": "\ua960-\ua97f",
    "^hanguljamoextendeda": "\u0000-\ua95f\ua980-\U0010ffff",
    "javanese": "\ua980-\ua9df",
    "^javanese": "\u0000-\ua97f\ua9e0-\U0010ffff",
    "cham": "\uaa00-\uaa5f",
    "^cham": "\u0000-\ua9ff\uaa60-\U0010ffff",
    "myanmarextendeda": "\uaa60-\uaa7f",
    "^myanmarextendeda": "\u0000-\uaa5f\uaa80-\U0010ffff",
    "taiviet": "\uaa80-\uaadf",
    "^taiviet": "\u0000-\uaa7f\uaae0-\U0010ffff",
    "meeteimayekextensions": "\uaae0-\uaaff",
    "^meeteimayekextensions": "\u0000-\uaadf\uab00-\U0010ffff",
    "ethiopicextendeda": "\uab00-\uab2f",
    "^ethiopicextendeda": "\u0000-\uaaff\uab30-\U0010ffff",
    "meeteimayek": "\uabc0-\uabff",
    "^meeteimayek": "\u0000-\uabbf\uac00-\U0010ffff",
    "hangulsyllables": "\uac00-\ud7af",
    "^hangulsyllables": "\u0000-\uabff\ud7b0-\U0010ffff",
    "hanguljamoextendedb": "\ud7b0-\ud7ff",
    "^hanguljamoextendedb": "\u0000-\ud7af\ud800-\U0010ffff",
    "highsurrogates": "\ud800-\udb7f",
    "^highsurrogates": "\u0000-\ud7ff\udb80-\U0010ffff",
    "highprivateusesurrogates": "\udb80-\udbff",
    "^highprivateusesurrogates": "\u0000-\udb7f\udc00-\U0010ffff",
    "lowsurrogates": "\udc00-\udfff",
    "^lowsurrogates": "\u0000-\udbff\ue000-\U0010ffff",
    "privateusearea": "\ue000-\uf8ff",
    "^privateusearea": "\u0000-\udfff\uf900-\U0010ffff",
    "cjkcompatibilityideographs": "\uf900-\ufaff",
    "^cjkcompatibilityideographs": "\u0000-\uf8ff\ufb00-\U0010ffff",
    "alphabeticpresentationforms": "\ufb00-\ufb4f",
    "^alphabeticpresentationforms": "\u0000-\ufaff\ufb50-\U0010ffff",
    "arabicpresentationformsa": "\ufb50-\ufdff",
    "^arabicpresentationformsa": "\u0000-\ufb4f\ufe00-\U0010ffff",
    "variationselectors": "\ufe00-\ufe0f",
    "^variationselectors": "\u0000-\ufdff\ufe10-\U0010ffff",
    "verticalforms": "\ufe10-\ufe1f",
    "^verticalforms": "\u0000-\ufe0f\ufe20-\U0010ffff",
    "combininghalfmarks": "\ufe20-\ufe2f",
    "^combininghalfmarks": "\u0000-\ufe1f\ufe30-\U0010ffff",
    "cjkcompatibilityforms": "\ufe30-\ufe4f",
    "^cjkcompatibilityforms": "\u0000-\ufe2f\ufe50-\U0010ffff",
    "smallformvariants": "\ufe50-\ufe6f",
    "^smallformvariants": "\u0000-\ufe4f\ufe70-\U0010ffff",
    "arabicpresentationformsb": "\ufe70-\ufeff",
    "^arabicpresentationformsb": "\u0000-\ufe6f\uff00-\U0010ffff",
    "halfwidthandfullwidthforms": "\uff00-\uffef",
    "^halfwidthandfullwidthforms": "\u0000-\ufeff\ufff0-\U0010ffff",
    "specials": "\ufff0-\uffff",
    "^specials": "\u0000-\uffef\U00010000-\U0010ffff",
    "linearbsyllabary": "\U00010000-\U0001007f",
    "^linearbsyllabary": "\u0000-\uffff\U00010080-\U0010ffff",
    "linearbideograms": "\U00010080-\U000100ff",
    "^linearbideograms": "\u0000-\U0001007f\U00010100-\U0010ffff",
    "aegeannumbers": "\U00010100-\U0001013f",
    "^aegeannumbers": "\u0000-\U000100ff\U00010140-\U0010ffff",
    "ancientgreeknumbers": "\U00010140-\U0001018f",
    "^ancientgreeknumbers": "\u0000-\U0001013f\U00010190-\U0010ffff",
    "ancientsymbols": "\U00010190-\U000101cf",
    "^ancientsymbols": "\u0000-\U0001018f\U000101d0-\U0010ffff",
    "phaistosdisc": "\U000101d0-\U000101ff",
    "^phaistosdisc": "\u0000-\U000101cf\U00010200-\U0010ffff",
    "lycian": "\U00010280-\U0001029f",
    "^lycian": "\u0000-\U0001027f\U000102a0-\U0010ffff",
    "carian": "\U000102a0-\U000102df",
    "^carian": "\u0000-\U0001029f\U000102e0-\U0010ffff",
    "olditalic": "\U00010300-\U0001032f",
    "^olditalic": "\u0000-\U000102ff\U00010330-\U0010ffff",
    "gothic": "\U00010330-\U0001034f",
    "^gothic": "\u0000-\U0001032f\U00010350-\U0010ffff",
    "ugaritic": "\U00010380-\U0001039f",
    "^ugaritic": "\u0000-\U0001037f\U000103a0-\U0010ffff",
    "oldpersian": "\U000103a0-\U000103df",
    "^oldpersian": "\u0000-\U0001039f\U000103e0-\U0010ffff",
    "deseret": "\U00010400-\U0001044f",
    "^deseret": "\u0000-\U000103ff\U00010450-\U0010ffff",
    "shavian": "\U00010450-\U0001047f",
    "^shavian": "\u0000-\U0001044f\U00010480-\U0010ffff",
    "osmanya": "\U00010480-\U000104af",
    "^osmanya": "\u0000-\U0001047f\U000104b0-\U0010ffff",
    "cypriotsyllabary": "\U00010800-\U0001083f",
    "^cypriotsyllabary": "\u0000-\U000107ff\U00010840-\U0010ffff",
    "imperialaramaic": "\U00010840-\U0001085f",
    "^imperialaramaic": "\u0000-\U0001083f\U00010860-\U0010ffff",
    "phoenician": "\U00010900-\U0001091f",
    "^phoenician": "\u0000-\U000108ff\U00010920-\U0010ffff",
    "lydian": "\U00010920-\U0001093f",
    "^lydian": "\u0000-\U0001091f\U00010940-\U0010ffff",
    "meroitichieroglyphs": "\U00010980-\U0001099f",
    "^meroitichieroglyphs": "\u0000-\U0001097f\U000109a0-\U0010ffff",
    "meroiticcursive": "\U000109a0-\U000109ff",
    "^meroiticcursive": "\u0000-\U0001099f\U00010a00-\U0010ffff",
    "kharoshthi": "\U00010a00-\U00010a5f",
    "^kharoshthi": "\u0000-\U000109ff\U00010a60-\U0010ffff",
    "oldsoutharabian": "\U00010a60-\U00010a7f",
    "^oldsoutharabian": "\u0000-\U00010a5f\U00010a80-\U0010ffff",
    "avestan": "\U00010b00-\U00010b3f",
    "^avestan": "\u0000-\U00010aff\U00010b40-\U0010ffff",
    "inscriptionalparthian": "\U00010b40-\U00010b5f",
    "^inscriptionalparthian": "\u0000-\U00010b3f\U00010b60-\U0010ffff",
    "inscriptionalpahlavi": "\U00010b60-\U00010b7f",
    "^inscriptionalpahlavi": "\u0000-\U00010b5f\U00010b80-\U0010ffff",
    "oldturkic": "\U00010c00-\U00010c4f",
    "^oldturkic": "\u0000-\U00010bff\U00010c50-\U0010ffff",
    "ruminumeralsymbols": "\U00010e60-\U00010e7f",
    "^ruminumeralsymbols": "\u0000-\U00010e5f\U00010e80-\U0010ffff",
    "brahmi": "\U00011000-\U0001107f",
    "^brahmi": "\u0000-\U00010fff\U00011080-\U0010ffff",
    "kaithi": "\U00011080-\U000110cf",
    "^kaithi": "\u0000-\U0001107f\U000110d0-\U0010ffff",
    "sorasompeng": "\U000110d0-\U000110ff",
    "^sorasompeng": "\u0000-\U000110cf\U00011100-\U0010ffff",
    "chakma": "\U00011100-\U0001114f",
    "^chakma": "\u0000-\U000110ff\U00011150-\U0010ffff",
    "sharada": "\U00011180-\U000111df",
    "^sharada": "\u0000-\U0001117f\U000111e0-\U0010ffff",
    "takri": "\U00011680-\U000116cf",
    "^takri": "\u0000-\U0001167f\U000116d0-\U0010ffff",
    "cuneiform": "\U00012000-\U000123ff",
    "^cuneiform": "\u0000-\U00011fff\U00012400-\U0010ffff",
    "cuneiformnumbersandpunctuation": "\U00012400-\U0001247f",
    "^cuneiformnumbersandpunctuation": "\u0000-\U000123ff\U00012480-\U0010ffff",
    "egyptianhieroglyphs": "\U00013000-\U0001342f",
    "^egyptianhieroglyphs": "\u0000-\U00012fff\U00013430-\U0010ffff",
    "bamumsupplement": "\U00016800-\U00016a3f",
    "^bamumsupplement": "\u0000-\U000167ff\U00016a40-\U0010ffff",
    "miao": "\U00016f00-\U00016f9f",
    "^miao": "\u0000-\U00016eff\U00016fa0-\U0010ffff",
    "kanasupplement": "\U0001b000-\U0001b0ff",
    "^kanasupplement": "\u0000-\U0001afff\U0001b100-\U0010ffff",
    "byzantinemusicalsymbols": "\U0001d000-\U0001d0ff",
    "^byzantinemusicalsymbols": "\u0000-\U0001cfff\U0001d100-\U0010ffff",
    "musicalsymbols": "\U0001d100-\U0001d1ff",
    "^musicalsymbols": "\u0000-\U0001d0ff\U0001d200-\U0010ffff",
    "ancientgreekmusicalnotation": "\U0001d200-\U0001d24f",
    "^ancientgreekmusicalnotation": "\u0000-\U0001d1ff\U0001d250-\U0010ffff",
    "taixuanjingsymbols": "\U0001d300-\U0001d35f",
    "^taixuanjingsymbols": "\u0000-\U0001d2ff\U0001d360-\U0010ffff",
    "countingrodnumerals": "\U0001d360-\U0001d37f",
    "^countingrodnumerals": "\u0000-\U0001d35f\U0001d380-\U0010ffff",
    "mathematicalalphanumericsymbols": "\U0001d400-\U0001d7ff",
    "^mathematicalalphanumericsymbols": "\u0000-\U0001d3ff\U0001d800-\U0010ffff",
    "arabicmathematicalalphabeticsymbols": "\U0001ee00-\U0001eeff",
    "^arabicmathematicalalphabeticsymbols": "\u0000-\U0001edff\U0001ef00-\U0010ffff",
    "mahjongtiles": "\U0001f000-\U0001f02f",
    "^mahjongtiles": "\u0000-\U0001efff\U0001f030-\U0010ffff",
    "dominotiles": "\U0001f030-\U0001f09f",
    "^dominotiles": "\u0000-\U0001f02f\U0001f0a0-\U0010ffff",
    "playingcards": "\U0001f0a0-\U0001f0ff",
    "^playingcards": "\u0000-\U0001f09f\U0001f100-\U0010ffff",
    "enclosedalphanumericsupplement": "\U0001f100-\U0001f1ff",
    "^enclosedalphanumericsupplement": "\u0000-\U0001f0ff\U0001f200-\U0010ffff",
    "enclosedideographicsupplement": "\U0001f200-\U0001f2ff",
    "^enclosedideographicsupplement": "\u0000-\U0001f1ff\U0001f300-\U0010ffff",
    "miscellaneoussymbolsandpictographs": "\U0001f300-\U0001f5ff",
    "^miscellaneoussymbolsandpictographs": "\u0000-\U0001f2ff\U0001f600-\U0010ffff",
    "emoticons": "\U0001f600-\U0001f64f",
    "^emoticons": "\u0000-\U0001f5ff\U0001f650-\U0010ffff",
    "transportandmapsymbols": "\U0001f680-\U0001f6ff",
    "^transportandmapsymbols": "\u0000-\U0001f67f\U0001f700-\U0010ffff",
    "alchemicalsymbols": "\U0001f700-\U0001f77f",
    "^alchemicalsymbols": "\u0000-\U0001f6ff\U0001f780-\U0010ffff",
    "cjkunifiedideographsextensionb": "\U00020000-\U0002a6df",
    "^cjkunifiedideographsextensionb": "\u0000-\U0001ffff\U0002a6e0-\U0010ffff",
    "cjkunifiedideographsextensionc": "\U0002a700-\U0002b73f",
    "^cjkunifiedideographsextensionc": "\u0000-\U0002a6ff\U0002b740-\U0010ffff",
    "cjkunifiedideographsextensiond": "\U0002b740-\U0002b81f",
    "^cjkunifiedideographsextensiond": "\u0000-\U0002b73f\U0002b820-\U0010ffff",
    "cjkcompatibilityideographssupplement": "\U0002f800-\U0002fa1f",
    "^cjkcompatibilityideographssupplement": "\u0000-\U0002f7ff\U0002fa20-\U0010ffff",
    "tags": "\U000e0000-\U000e007f",
    "^tags": "\u0000-\U000dffff\U000e0080-\U0010ffff",
    "variationselectorssupplement": "\U000e0100-\U000e01ef",
    "^variationselectorssupplement": "\u0000-\U000e00ff\U000e01f0-\U0010ffff",
    "supplementaryprivateuseareaa": "\U000f0000-\U000fffff",
    "^supplementaryprivateuseareaa": "\u0000-\U000effff\U00100000-\U0010ffff",
    "supplementaryprivateuseareab": "\U00100000-\U0010ffff",
    "^supplementaryprivateuseareab": "\u0000-\U000fffff",
    "noblock": "\u0860-\u089f\u1ab0-\u1aff\u1c80-\u1cbf\u2fe0-\u2fef\ua9e0-\ua9ff\uab30-\uabbf\U00010200-\U0001027f\U000102e0-\U000102ff\U00010350-\U0001037f\U000103e0-\U000103ff\U000104b0-\U000107ff\U00010860-\U000108ff\U00010940-\U0001097f\U00010a80-\U00010aff\U00010b80-\U00010bff\U00010c50-\U00010e5f\U00010e80-\U00010fff\U00011150-\U0001117f\U000111e0-\U0001167f\U000116d0-\U00011fff\U00012480-\U00012fff\U00013430-\U000167ff\U00016a40-\U00016eff\U00016fa0-\U0001afff\U0001b100-\U0001cfff\U0001d250-\U0001d2ff\U0001d380-\U0001d3ff\U0001d800-\U0001edff\U0001ef00-\U0001efff\U0001f650-\U0001f67f\U0001f780-\U0001ffff\U0002a6e0-\U0002a6ff\U0002b820-\U0002f7ff\U0002fa20-\U000dffff\U000e0080-\U000e00ff\U000e01f0-\U000effff",
    "^noblock": "\u0000-\u085f\u08a0-\u1aaf\u1b00-\u1c7f\u1cc0-\u2fdf\u2ff0-\ua9df\uaa00-\uab2f\uabc0-\U000101ff\U00010280-\U000102df\U00010300-\U0001034f\U00010380-\U000103df\U00010400-\U000104af\U00010800-\U0001085f\U00010900-\U0001093f\U00010980-\U00010a7f\U00010b00-\U00010b7f\U00010c00-\U00010c4f\U00010e60-\U00010e7f\U00011000-\U0001114f\U00011180-\U000111df\U00011680-\U000116cf\U00012000-\U0001247f\U00013000-\U0001342f\U00016800-\U00016a3f\U00016f00-\U00016f9f\U0001b000-\U0001b0ff\U0001d000-\U0001d24f\U0001d300-\U0001d37f\U0001d400-\U0001d7ff\U0001ee00-\U0001eeff\U0001f000-\U0001f64f\U0001f680-\U0001f77f\U00020000-\U0002a6df\U0002a700-\U0002b81f\U0002f800-\U0002fa1f\U000e0000-\U000e007f\U000e0100-\U000e01ef",
}
